;=====================================================================
; Program name: Intervall Trainer
; Programmed by: [-alloces-] <alloces@gmx.net>
; Finished: 04/02/2001
;=====================================================================

.386
.model flat, stdcall  
option casemap :none  

include \MASM32\INCLUDE\windows.inc
include \MASM32\INCLUDE\gdi32.inc
include \MASM32\INCLUDE\user32.inc
include \MASM32\INCLUDE\kernel32.inc
include \MASM32\INCLUDE\winmm.inc     
includelib \MASM32\LIB\gdi32.lib
includelib \MASM32\LIB\user32.lib
includelib \MASM32\LIB\kernel32.lib
includelib \MASM32\LIB\winmm.lib

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
TopXY PROTO   :DWORD,:DWORD
Paint_Proc   PROTO :DWORD,:DWORD
packdword    PROTO :DWORD,:DWORD,:DWORD
playnote     PROTO :DWORD,:DWORD,:DWORD
midioutshort PROTO :DWORD,:DWORD,:DWORD
StaticBox PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
PushButton PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
ListBox PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
random proto :DWORD,:DWORD
randomize proto
setnote proto :DWORD
ListBoxProc proto :DWORD,:DWORD,:DWORD,:DWORD
checkrightint proto
getrightint proto
wsprintfA PROTO C :DWORD,:VARARG
wsprintf equ <wsprintfA>

m2m MACRO M1, M2
     push M2
     pop  M1
ENDM

return MACRO arg
     mov eax, arg
     ret
ENDM

.data
	szDisplayName db "Intervall Trainer",0
	szClassName   db "Win_Class",0
	StaticClass   db "STATIC",0
	ListClass     db "LISTBOX",0
	ButtonClass   db "BUTTON",0
	szformat      db "%u",0
	CommandLine   dd 0
        hWnd          dd 0
        hInstance     dd 0
        hIcon         dd 0
	cdauf    db "Set CDaudio door open",0
	cdzu     db "Set CDaudio door closed",0
	text1    db "Mache einen Doppelklick auf den Namen des Intervalls den du gehrt hast.",0
	richtigtext db "Ja, das ist richtig!",0
	falschtext  db "Leider falsch! Es wre eine %s gewesen.",0
	text2    db "Statistik",13,10,"~~~~~~~~~~~",0
	temptext3    db "Du hast %s von %s richtig!",0
	text3 db 50 dup(?),0
	button1text db "Spiele Intervall!",0
	button2text db "Nochmal bitte!",0
	intervall1 db "Prime",0
	intervall2 db "Sekunde",0
	intervall3 db "Terz",0
	intervall4 db "Quarte",0
	intervall5 db "Quinte",0
	intervall6 db "Sexte",0
	intervall7 db "Septime",0
	intervall8 db "Oktave",0
	insgesamt dd 0
	richtig dd 0
	strinsgesamt db 10 dup(?),0
	strrichtig db 10 dup(?),0
	falschbuffer db 50 dup(?),0
	
.data?
	hmidi    dd ?
	volume db ?
	basenote db ?
	midimsg dd ?
	listboxhwnd HWND ?
	rand dd ?
	button1hwnd HWND ?
	button2hwnd HWND ?
	notenstring db 10 dup(?)
	cur1note dd ?
	cur2note dd ?
	rightint dd ?
	note1number dd ?
	note2number dd ?
	oldlistproc dd ?
	statistikhwnd dd ?

.code

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

; #########################################################################

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

      ;====================
      ; Put LOCALs on stack
      ;====================

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG
      LOCAL Wwd  :DWORD
      LOCAL Wht  :DWORD
      LOCAL Wtx  :DWORD
      LOCAL Wty  :DWORD

      invoke LoadIcon,hInst,1001    ; icon ID
      mov hIcon, eax
      mov wc.cbSize,         sizeof WNDCLASSEX
      mov wc.style,          CS_HREDRAW or CS_VREDRAW
      mov wc.lpfnWndProc,    offset WndProc
      mov wc.cbClsExtra,     NULL
      mov wc.cbWndExtra,     NULL
      m2m wc.hInstance,      hInst
      invoke CreateSolidBrush,00000000h
      push eax
      mov wc.hbrBackground,  eax
      pop eax
      invoke DeleteObject,eax
      ;invoke CreateSolidBrush, 060BC0h
      
      mov wc.lpszMenuName,   NULL
      mov wc.lpszClassName,  offset szClassName
      m2m wc.hIcon,          hIcon
        invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,        eax
      m2m wc.hIconSm,        hIcon

      invoke RegisterClassEx, ADDR wc

      ;================================
      ; Centre window at following size
      ;================================

      mov Wwd, 550
      mov Wht, 230

      invoke GetSystemMetrics,SM_CXSCREEN
      invoke TopXY,Wwd,eax
      mov Wtx, eax

      invoke GetSystemMetrics,SM_CYSCREEN
      invoke TopXY,Wht,eax
      mov Wty, eax

      invoke CreateWindowEx,WS_EX_LEFT,
                            ADDR szClassName,
                            ADDR szDisplayName,
                            WS_OVERLAPPED or WS_SYSMENU or WS_MINIMIZEBOX,
                            Wtx,Wty,Wwd,Wht,
                            NULL,NULL,
                            hInst,NULL
      mov   hWnd,eax

      invoke LoadMenu,hInst,600  ; menu ID
      invoke SetMenu,hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain endp

; #########################################################################

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
    

    
    ;======== menu commands ========
    .if uMsg == WM_CREATE
	invoke StaticBox,addr text1,hWin,15,15,500,25,1000
	
	invoke PushButton,addr button1text,hWin,180,60,125,25,1
	mov button1hwnd,eax
	
	invoke PushButton,addr button2text,hWin,330,60,125,25,2
	mov button2hwnd,eax
	invoke EnableWindow,button2hwnd,FALSE
	
	invoke StaticBox,addr text2,hWin,290,110,60,30,1001
	
	invoke wsprintf,addr strrichtig,addr szformat,richtig
	invoke wsprintf,addr strinsgesamt,addr szformat,insgesamt
	invoke wsprintf,addr text3,addr temptext3,addr strrichtig,addr strinsgesamt
	invoke StaticBox,addr text3,hWin,172,160,300,25,1002
	mov statistikhwnd,eax
	
	invoke ListBox,hWin,15,60,100,200,2000
	mov listboxhwnd,eax
	invoke SetWindowLong,listboxhwnd,GWL_WNDPROC,ListBoxProc
	mov oldlistproc,eax
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall1
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall2
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall3
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall4
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall5
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall6
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall7
	invoke SendMessage,listboxhwnd,LB_ADDSTRING,0,addr intervall8
	invoke EnableWindow,listboxhwnd,FALSE
	
	invoke midiOutOpen,ADDR hmidi, -1, 0, 0, 0    ;|> -1 ist das device, scheint standard zu sein
	;invoke midioutshort,90h,62,127          ;|> 90h = ton spielen
						;|> 80h = ton stoppen
    						;|> 60 ist die tonhhe, und 127 die lautstaerke
    						;|> 60 entspricht c
    	;invoke mciExecute,addr cdauf
    
    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
          mov hDC, eax
          invoke Paint_Proc,hWin,hDC
        invoke EndPaint,hWin,ADDR Ps
        return 0
    
    .ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.IF lParam==0
			;|> menu wurde gedrckt
		.ELSE
			.IF ax==1
				shr eax,16
				.IF ax==BN_CLICKED
					invoke EnableWindow,button2hwnd,FALSE
					invoke EnableWindow,button1hwnd,FALSE
					invoke EnableWindow,listboxhwnd,FALSE
					invoke randomize
					invoke random,0,7
					mov note1number,eax
					invoke setnote,eax
					add eax,60
					mov cur1note,eax
					invoke midioutshort,90h,eax,127
					invoke Sleep,4000
					
				_nochmal:
					invoke random,0,7
					cmp eax,note1number
					jb _nochmal
					mov note2number,eax
					invoke setnote,eax
					add eax,60
					mov cur2note,eax
					invoke midioutshort,90h,eax,127
					invoke Sleep,4000
					invoke EnableWindow,button2hwnd,TRUE
					invoke EnableWindow,listboxhwnd,TRUE
					invoke getrightint
					
				.ENDIF
			.ELSEIF ax==2
				shr eax,16
				.IF ax==BN_CLICKED
					invoke SendMessage,listboxhwnd,LB_SETCURSEL,-1,0
					invoke EnableWindow,listboxhwnd,FALSE
					invoke UpdateWindow,listboxhwnd
					invoke EnableWindow,button2hwnd,FALSE
					
					invoke midioutshort,90h,cur1note,127
					invoke Sleep,4000
					invoke midioutshort,90h,cur2note,127
					invoke Sleep,4000
					invoke EnableWindow,button2hwnd,TRUE
					invoke EnableWindow,listboxhwnd,TRUE
				.ENDIF
			.ENDIF
		.ENDIF
        
   
    .elseif uMsg==WM_CTLCOLORSTATIC
    	invoke SetTextColor,wParam,Yellow
    	invoke SetBkColor,wParam,Black
    	invoke GetStockObject,BLACK_BRUSH
    	ret
    	
    .elseif uMsg==WM_CTLCOLORLISTBOX
    	invoke SetTextColor,wParam,White
    	invoke SetBkColor,wParam,Black
    	invoke GetStockObject,BLACK_BRUSH
    	ret

    .elseif uMsg == WM_DESTROY
        invoke midiOutClose,hmidi
        invoke PostQuitMessage,NULL
        return 0 
    .else

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
	.endif
    ret

WndProc endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      
    shr wDim, 1     
    mov eax, wDim   
    sub sDim, eax 

    return sDim

TopXY endp

; #########################################################################

Paint_Proc proc hWin:DWORD, hDC:DWORD

    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax

    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax

    return 0

Paint_Proc endp

; ########################################################################

packdword PROC i2: DWORD,i3: DWORD,i4: DWORD
	xor	ebx,ebx
	mov	eax,i2
	xor	edx,edx
	mov     ecx,10000h
	mul	ecx
	xchg	ebx,eax
	xor	edx,edx
	mov	eax,i3
	mov     ecx,100h
	mul	ecx
	add	ebx,eax
	mov	eax,i4
	add	eax,ebx
	ret
packdword ENDP
	
midioutshort proc b1:DWORD,b2:DWORD,b3:DWORD
	invoke packdword,b3,b2,b1
	invoke midiOutShortMsg,hmidi,eax
	ret
midioutshort endp

StaticBox proc inhalt:DWORD,hwndFenster:DWORD,a:DWORD,b:DWORD,wdth:DWORD,hght:DWORD,Ident:DWORD
	
	;invoke StaticBox,addr buffer1,hWin,25,25,100,50,1000
	invoke CreateWindowEx,WS_EX_LEFT, ADDR StaticClass,NULL,\
                        WS_CHILD or WS_VISIBLE or SS_CENTER,
                        a,b,wdth,hght,hwndFenster,Ident,hInstance,NULL
        push eax
        invoke SetWindowText,eax,inhalt
        pop eax
        ret
StaticBox endp

PushButton proc inhalt:DWORD,hwndFenster:DWORD,a:DWORD,b:DWORD,wdth:DWORD,hght:DWORD,Ident:DWORD
	
	;invoke PushButton,addr buffer1,hWin,25,25,100,50,1000
	invoke CreateWindowEx,NULL, ADDR ButtonClass,NULL,\
                        WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON or BS_CENTER or BS_TEXT,
                        a,b,wdth,hght,hwndFenster,Ident,hInstance,NULL
        push eax
        invoke SetWindowText,eax,inhalt
        pop eax
        ret
PushButton endp

ListBox proc hwndFenster:DWORD,a:DWORD,b:DWORD,wdth:DWORD,hght:DWORD,Ident:DWORD
	
	;invoke ListBox,addr buffer1,hWin,25,25,100,50,1000
	invoke CreateWindowEx,WS_EX_LEFT, ADDR ListClass,NULL,\
                        WS_CHILD or WS_VISIBLE or LBS_NOTIFY,
                        a,b,wdth,hght,hwndFenster,Ident,hInstance,NULL
        ret
ListBox endp

random PROC first:DWORD,second:DWORD
	mov ebx,second
	sub ebx,first
	inc ebx
	xor edx,edx
	mov eax,rand
	div ebx
	add rand,eax
	add edx,first
	mov eax,edx
	ret
random ENDP

randomize proc
	invoke GetTickCount
	mov rand,eax
	ret
randomize endp

setnote proc notenumber:DWORD
	mov ecx,notenumber
	.if ecx==0
		mov eax,0
	.elseif ecx==1	
		mov eax,2
	.elseif ecx==2
		mov eax,4
	.elseif ecx==3
		mov eax,5
	.elseif ecx==4
		mov eax,7
	.elseif ecx==5
		mov eax,9
	.elseif ecx==6
		mov eax,11
	.elseif ecx==7
		mov eax,12
	.endif
	ret
setnote endp

getrightint proc
	mov eax,note2number
	mov ecx,note1number
	sub eax,ecx
	add eax,1
	mov rightint,eax
	ret
getrightint endp

ListBoxProc proc hCtl:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.if uMsg == WM_LBUTTONDBLCLK
		invoke SendMessage,hCtl,LB_GETCURSEL,0,0
		add eax,1
        	.if eax==rightint
			invoke MessageBox,hWnd,addr richtigtext,addr szDisplayName,MB_OK
			add richtig,1
			add insgesamt,1
			invoke EnableWindow,button1hwnd,TRUE
    			invoke EnableWindow,button2hwnd,FALSE
    			invoke EnableWindow,hCtl,FALSE
    			invoke SendMessage,listboxhwnd,LB_SETCURSEL,-1,0
    			invoke wsprintf,addr strrichtig,addr szformat,richtig
			invoke wsprintf,addr strinsgesamt,addr szformat,insgesamt
			invoke wsprintf,addr text3,addr temptext3,addr strrichtig,addr strinsgesamt
			invoke SetWindowText,statistikhwnd,addr text3
		.else 
			invoke checkrightint
			invoke MessageBox,hWnd,addr falschbuffer,addr szDisplayName,MB_OK
			add insgesamt,1
			invoke SendMessage,listboxhwnd,LB_SETCURSEL,-1,0
			invoke EnableWindow,button1hwnd,TRUE
    			invoke EnableWindow,button2hwnd,FALSE
    			invoke EnableWindow,hCtl,FALSE
    			invoke wsprintf,addr strrichtig,addr szformat,richtig
			invoke wsprintf,addr strinsgesamt,addr szformat,insgesamt
			invoke wsprintf,addr text3,addr temptext3,addr strrichtig,addr strinsgesamt
			invoke SetWindowText,statistikhwnd,addr text3
    		.endif
    	.endif  
        invoke CallWindowProc,oldlistproc,listboxhwnd,uMsg,wParam,lParam
    	ret
ListBoxProc endp

checkrightint proc
	.if rightint==1
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall1
	.elseif rightint==2
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall2
	.elseif rightint==3
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall3
	.elseif rightint==4
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall4
	.elseif rightint==5
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall5
	.elseif rightint==6
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall6
	.elseif rightint==7
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall7
	.elseif rightint==8
		invoke wsprintf,addr falschbuffer,addr falschtext,addr intervall8
	.endif
	ret
checkrightint endp

end start

